unit fdm;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, VpZeosDs, VpFlxDS, VpBaseDS, ZConnection,
  ZDataset;

type

  { TDM }

  TDM = class(TDataModule)
    DSEvents: TDataSource;
    DSTask: TDataSource;
    DSContacs: TDataSource;
    DSResource: TDataSource;
    VpCLVPad: TVpControlLink;
    VpFDSVPad: TVpFlexDataStore;
    VpZDVPad: TVpZeosDatastore;
    ZCVPad: TZConnection;
    ZQResources: TZQuery;
    ZQContacts: TZQuery;
    ZQevents: TZQuery;
    ZQTask: TZQuery;
    ZROQT: TZReadOnlyQuery;
    ZTVPad: TZTransaction;
    procedure DataModuleCreate(Sender: TObject);
    procedure VpZDVPadAfterPostContacts(Sender: TObject);
    procedure ZCVPadAfterConnect(Sender: TObject);
    procedure ZTVPadAfterCommit(Sender: TObject);
  private
    procedure checaTablas();

  public

  end;

var
  DM: TDM;

implementation

{$R *.frm}

{ TDM }

procedure TDM.DataModuleCreate(Sender: TObject);
begin
  if( ZCVPad.Connected = false) then begin
     ZCVPad.LibraryLocation:= GetCurrentDir+'\libmysql.dll';
     ZCVPad.Connected:=true;
     ChecaTablas();
     VpZDVPad.AutoCreate:=true;
     VpZDVPad.AutoConnect:=true;
     VpFDSVPad.AutoCreate:=true;
     VpFDSVPad.AutoConnect:=true;

  end;

end;

procedure TDM.VpZDVPadAfterPostContacts(Sender: TObject);
begin

end;

procedure TDM.ZCVPadAfterConnect(Sender: TObject);
begin

end;

procedure TDM.ZTVPadAfterCommit(Sender: TObject);
begin

end;

Procedure TDm.checaTablas();
begin
  ZCVPad.ExecuteDirect('CREATE TABLE IF NOT EXISTS contacts('+
  'recordId INT NOT NULL AUTO_INCREMENT , '+
  'ResourceId INT NOT NULL,'+
  'FirstName varchar(50)  , '+
  'Lastname varchar(50)  ,   '+
  'midlename varchar(50) , '+
  'category INT  not NULL,  '+
  'BirthDate date  ,   '+
  'anniversary date  ,  '+
  'Title varchar(50)  ,  '+
  'company varchar(60)  , '+
  'Departament varchar(50)  ,'+
  'job_position varchar(30)  ,'+
  'AddressType1 INT NOT NULL,  '+
  'address1 varchar(120)  ,   '+
  'Address2 varchar(120)  ,    '+
  'city1 varchar(60)  ,       '+
  'City2 varchar(60)  ,      '+
  'State1 varchar(35)  ,      '+
  'State2 varchar(35)  ,      '+
  'Zip1 varchar(10)  ,        '+
  'Zip2 varchar(10)  ,        '+
  'coutry1 varchar(40)  ,    '+
  'Country2 varchar(40)  ,   '+
  'PhoneType1 smallint(6)  , '+
  'PhoneType2 smallint(6)  , '+
  'PhoneType3 smallint(6)  ,  '+
  'Phonetype4 smallint(6)  ,  '+
  'PhoneType5 smallint(6)  ,   '+
  'Phone1 varchar(25)  ,      '+
  'Phone2 varchar(25)  ,      '+
  'Phone3 varchar(25)  ,      '+
  'Phone4 varchar(25)  ,     '+
  'Phone5 varchar(25)  ,     '+
  'EmailType1 smallint(6)  , '+
  'EmailType2 smallint(6)  , '+
  'EmailType3 smallint(6)  , '+
  'Email1 varchar(125)  ,     '+
  'Email2 varchar(125)  ,    '+
  'Email3 varchar(125)  ,    '+
  'WebSiteType1 smallint(6)  , '+
  'WebSiteType2 smallint(6)  , '+
  'WebSite1 varchar(120)  ,    '+
  'WebSite2 varchar(120)  ,    '+
  'Custom1 varchar(100)  ,     '+
  'Custom2 varchar(100)  ,     '+
  'Custom3 varchar(100)  ,     '+
  'Custom4 varchar(100)  ,    '+
  'UserField0 varchar(120)  , '+
  'UserField1 varchar(120)  , '+
  'UserField2 varchar(120)  , '+
  'UserField4 varchar(120)  ,  '+
  'UserField3 varchar(120)  ,  '+
  'UserField5 varchar(120)  ,  '+
  'UserField6 varchar(120)  , '+
  'UserField7 varchar(120)  ,  '+
  'UserField8 varchar(120)  ,  '+
  'UserField9 varchar(120)  ,  '+
  'Department varchar(50)   ,  '+
  'AddressType2 INT NOT NULL , '+
  'PRIMARY KEY (recordId) ,    '+
  'KEY company (company) ,     '+
  'KEY FirstName (FirstName,Lastname) '+
  '); '
 );

  ZCVPad.ExecuteDirect('CREATE TABLE IF NOT EXISTS events('+
  'RecordId INT NOT NULL AUTO_INCREMENT ,'+
  'ResourceID INT NOT NULL , '+
  'StartTime timestamp ,    '+
  'Endtime timestamp ,      '+
  'Description varchar(120)  , '+
  'Location varchar(100)  ,  '+
  'Notes text ,            '+
  'category INT NOT NULL,  '+
  'AllDay tinyint(1)  ,    '+
  'DingPath varchar(255)  , '+
  'AlarmSet tinyint(1)  ,   '+
  'AlarmAdvance INT  ,      '+
  'AlarmAdvanceType INT  NOT NULL,'+
  'SnoozeTime timestamp , '+
  'RepeatCode INT  NOT NULL, '+
  'RepeatRangeEnd timestamp ,  '+
  'CustomInterval INT  NOT NULL, '+
  'UserField0 varchar(120)  , '+
  'UserField1 varchar(120)  , '+
  'UserField2 varchar(120)  , '+
  'UserField3 varchar(120)  , '+
  'UserField4 varchar(120)  , '+
  'UserField5 varchar(120)  , '+
  'UserField6 varchar(120)  , '+
  'UserField7 varchar(120)  , '+
  'UserField8 varchar(120)  , '+
  'UserField9 varchar(120)  , '+
  'PRIMARY KEY (RecordId),   '+
  'KEY Endtime (Endtime),   '+
  'KEY ResourceID (ResourceID),'+
  'KEY StartTime (StartTime) '+
  ');'

);

  ZCVPad.ExecuteDirect('CREATE TABLE IF NOT EXISTS resources('+
  'ResourceId INT NOT NULL AUTO_INCREMENT ,  '+
  'Description varchar(255) ,   '+
  'Notes text,                '+
  'ImageIndex INT NOT NULL,   '+
  'ResourceActive tinyint(1)  NULL, '+
  'UserField0 varchar(120)  NULL, '+
  'UserField1 varchar(120)  NULL, '+
  'UserField2 varchar(120)  NULL, '+
  'UserField3 varchar(120)  NULL, '+
  'UserField4 varchar(120)  NULL,  '+
  'UserField5 varchar(120)  NULL, '+
  'UserField6 varchar(120)  NULL, '+
  'UserField7 varchar(120)  NULL, '+
  'UserField8 varchar(120)  NULL,  '+
  'UserField9 varchar(120)  NULL,  '+
  'PRIMARY KEY (ResourceId),      '+
  'KEY ResurceId (ResourceId)   '+
  '); '
 );

  ZCVPad.ExecuteDirect('  CREATE TABLE IF NOT EXISTS  tasks( '+
    'RecordId INT NOT NULL AUTO_INCREMENT,  '+
   ' ResourceId INT not  NULL,            '+
   ' Complete tinyint(1)  NULL,           '+
   ' Description varchar(255)   NULL,     '+
   ' Details text ,                      '+
   ' CreationOn timestamp NULL,          '+
   ' Priority INT  NULL,                 '+
   ' Category INT  NULL,                 '+
   ' CompletedOn timestamp NULL,         '+
   ' DueDate timestamp NULL,             '+
   ' UserField0 varchar(120)   NULL,     '+
   ' UserField1 varchar(120)   NULL,     '+
   ' UserField2 varchar(120)   NULL,     '+
   ' UserField3 varchar(120)   NULL,     '+
   ' UserField4 varchar(120)   NULL,     '+
   ' UserField5 varchar(120)   NULL,     '+
   ' UserField6 varchar(120)   NULL,     '+
   ' UserField7 varchar(120)   NULL,     '+
   ' UserField8 varchar(120)   NULL,     '+
   ' UserField9 varchar(120)   NULL,      '+
   ' PRIMARY KEY (RecordId),          '+
   ' KEY CompletedOn (CompletedOn),   '+
   ' KEY DueDate (DueDate),          '+
   ' KEY ResourceId (ResourceId)   '+
   ');'
  );

  ZCVPad.ExecuteDirect('  CREATE TABLE IF NOT EXISTS usuarios('+
    'Id INT NOT NULL AUTO_INCREMENT, '+
    'username varchar(25)  NULL,  '+
    'password varchar(35)  NULL,  '+
    'nivel tinyint(4)  NULL,   '+
    'docsucid smallint(6)  NULL, '+
    'PRIMARY KEY (Id),  '+
   ' KEY Username (username) '+
  ' ); '
  );
  ZCVPad.ExecuteDirect('CREATE TABLE IF NOT EXISTS categorias( '+
    'Id INT NOT NULL AUTO_INCREMENT,   '+
    'cvecateg varchar(6)  ,         '+
    'descripcion varchar(120) ,    '+
    'PRIMARY KEY (Id)  '+
    ') ;'
    );

 end;
end.

