unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,FileUtil, PrintersDlgs, Forms, fgl,Controls, Graphics, Dialogs, ComCtrls, VpNavBar, Types,
  ExtCtrls, StdCtrls, LCLTranslator, Menus,  LCLVersion, Math,
  CheckLst, VpBaseDS, VpDayView, VpWeekView, VpTaskList, VpContactGrid,
  VpMonthView, VpResEditDlg, VpContactButtons, VpData, VpPrtPrvDlg,
  VpPrtFmtDlg, VpBase, VpEvntEditDlg, VpContactEditDlg;

type

  THolidayList = specialize TFPGMap<TDateTime, string>;

  { TFormMain }

  TFormMain = class(TForm)
    BtnNewRes: TButton;
    BtnEditRes: TButton;
    BtnDeleteRes: TButton;
    CbAddressBuilder: TComboBox;
    CbAllowInplaceEditing: TCheckBox;
    CbDrawingStyle: TComboBox;
    CbLanguages: TComboBox;
    HeaderPanel: TPanel;
    ILNavBar: TImageList;
    LblAddressBuilder: TLabel;
    LblDrawingStyle: TLabel;
    LblFirstDayOfWeek: TLabel;
    LblGranularity: TLabel;
    LblLanguage: TLabel;
    lblResources: TLabel;
    LblTimeFormat: TLabel;
    LblVisibleDays: TLabel;
    Panel1: TPanel;
    RbAllTasks: TRadioButton;
    StatusBar1: TStatusBar;
    TaskControlPanel: TPanel;
    ToolBar1: TToolBar;
    VpNavBar1: TVpNavBar;
    Notebook: TNotebook;
     lblOtherResources: TLabel;
     Events: TPage;
     OpenDialog: TOpenDialog;
     Splitter1: TSplitter;
     Tasks: TPage;
     Contacts: TPage;
     Resources: TPage;
     Settings: TPage;
     PrintDialog1: TPrintDialog;
     TitleLbl: TLabel;
     Img: TImage;
     Splitter2: TSplitter;
     Splitter3: TSplitter;
     DaysTrackBar: TTrackBar;
     VpDayView1: TVpDayView;
     LeftPanel: TPanel;
     CbAllowDragAndDrop: TCheckBox;
     CbDragDropTransparent: TCheckBox;
     CbShowEventHints: TCheckBox;
     CbApplyCategoryInfos: TCheckBox;
     CbShowSavePrompt: TCheckBox;
     DaySelectorPanel: TPanel;
     lbOtherResources: TCheckListBox;
     VpMonthView1: TVpMonthView;
     VpTaskList1: TVpTaskList;
     VpWeekView1: TVpWeekView;
    CbGranularity: TComboBox;
    CbTimeFormat: TComboBox;
    CbFirstDayOfWeek: TComboBox;
    RbHideCompletedTasks: TRadioButton;
    VpContactButtonBar1: TVpContactButtonBar;
    VpContactGrid1: TVpContactGrid;
    VpResourceCombo: TVpResourceCombo;
    VpREDVend: TVpResourceEditDialog;

    procedure BtnNewResClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImgClick(Sender: TObject);
    procedure ResourcesBeforeShow(ASender: TObject; ANewPage: TPage;
      ANewIndex: Integer);
    procedure VpNavBar1ItemClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; Index: Integer);

  private
     FLang: String;
     FActiveView: Integer;
     FVisibleDays: Integer;
     FResID: Integer;
     FLanguageDir: String;
     FHolidays: THolidayList;
     FHolidayYear: Integer;

    procedure BtnDeleteResClick(Sender: TObject);
    procedure BtnEditResClick(Sender: TObject);

    procedure SetActiveView(AValue: Integer);
    procedure ShowAllEvents;
    procedure ShowResources;
    procedure ShowSettings;
    procedure UpdateOtherResourcesList;

  public

  end;

var
  FormMain: TFormMain;

implementation

{$R *.frm}

  {$UNDEF UTF8_CALLS}
  {$IFDEF LCL}
    {$DEFINE UTF8_CALLS}
    {$IF (lcl_major=1) and (lcl_minor<=6)}
       {$UNDEF UTF8_CALLS}
    {$ENDIF}
  {$ENDIF}

  {$DEFINE NEW_ICONS}   // The same as in vp.inc
   uses
 {$IFDEF WINDOWS}
  Windows,
 {$ENDIF}
  LResources, LazFileUtils, LazUTF8, StrUtils, DateUtils, Translations,
 {$IFNDEF UTF8_CALLS}
  lConvEncoding,
 {$ENDIF}
  fdm,IniFiles, Printers,
  VpMisc, VpPrtFmt,
  sound, ExVpRptSetup
  ;
 resourcestring
  RSConfirmDeleteRes = 'Do you really want to delete resource %s?';
  RSEventsOverview = 'Events overview';
  RSEventsPerMonth = 'Events per month';
  RSEventsPerWeek = 'Events per week';
  RSEventsPerDay = 'Events per day';
  RSTasks = 'Tasks';
  RSContacts = 'Contacts';
  RSResources = 'Resources';
  RSSettings = 'Program settings';
  RSSettings_short = 'Settings';
  RSPlanner = 'Planner';
  RSMaintenance = 'Maintenance';
  RS24Hours = '24 hours';
  RS12Hours = '12 hours AM/PM';
  RS5Min = '5 min';
  RS6Min = '6 min';
  RS10Min = '10 min';
  RS15Min = '15 min';
  RS20Min = '20 min';
  RS30Min = '30 min';
  RS60Min = '60 min';
  RSSunday = 'Sunday';
  RSMonday = 'Monday';
  RSTuesday = 'Tuesday';
  RSWednesday = 'Wednesday';
  RSThursday = 'Thursday';
  RSFriday = 'Friday';
  RSSaturday = 'Saturday';
  RSFlat = 'flat';
  RS3d = '3D';
  RSBorderless = 'no border';

{ TFormMain }

procedure TFormMain.VpNavBar1ItemClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; Index: Integer);
begin
  Unused(Button, Shift);
  SetActiveView(VpNavBar1.ActiveFolder * 1000 + Index);
end;

procedure TFormMain.ResourcesBeforeShow(ASender: TObject; ANewPage: TPage;
  ANewIndex: Integer);
begin

end;

procedure TFormMain.BtnNewResClick(Sender: TObject);
begin
  VpREDVend.AddNewResource;
  UpdateOtherResourcesList;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin

end;

procedure TFormMain.ImgClick(Sender: TObject);
begin

end;

procedure TFormMain.SetActiveView(AValue: Integer);
var
  folderIndex, itemIndex: Integer;
begin
  FActiveView := AValue;
  folderIndex := AValue div 1000;
  itemIndex := AValue mod 1000;
  case folderIndex of
   0: case itemIndex of          // All planner items
        0: ShowAllEvents;        // show all
 //       1: ShowEventsPerMonth;   // Month view only
 //       2: ShowEventsPerWeek;    // Week view only
 //       3: ShowEventsPerDay;     // Day view only
//        4: ShowTasks;            // Tasks
//        5: ShowContacts;         // Contacts
      end;
   1: case itemIndex of
        0: ShowResources;
        1: ShowSettings;
      end;
  end;
end;
procedure TFormMain.ShowResources;
begin
  Notebook.PageIndex := 3;
  TitleLbl.Caption := RSResources;
  ILNavBar.GetBitmap(7, Img.Picture.Bitmap);
end;

procedure TFormMain.ShowSettings;
begin
  Notebook.PageIndex := 4;
  TitleLbl.Caption := RSSettings;
  ILNavBar.GetBitmap(8, Img.Picture.Bitmap);
end;

procedure TFormMain.ShowAllEvents;
begin
  Notebook.PageIndex := 0;
  VpDayView1.Parent := LeftPanel;
  VpMonthView1.Parent := LeftPanel;
  VpMonthView1.Align := alBottom;
  VpDayview1.Show;
  VpMonthView1.Show;
  Splitter2.Top := 0;
  LeftPanel.Show;
  Splitter3.Show;
  Splitter3.Left := Width;
  VpWeekView1.Show;
  DaySelectorPanel.Hide;
  VpDayView1.NumDays := 1;
  TitleLbl.Caption := RSEventsOverview;
  ILNavBar.GetBitmap(0, Img.Picture.Bitmap);
end;
procedure TFormmain.BtnEditResClick(Sender: TObject);
begin
  // Open the resource editor dialog, everything is done here.
  VpREDVend.Execute;
end;

// Adds a new resource


procedure TFormmain.UpdateOtherResourcesList;
begin
  lblOtherResources.Visible := DM.VpCLVPad.Datastore.Resources.Count > 0;
  lbOtherResources.Visible := Dm.VpCLVPad.Datastore.Resources.Count > 0;
end;
procedure TFormMain.BtnDeleteResClick(Sender: TObject);
var
  res: TVpResource;
begin
  res := Dm.VpCLVPad.Datastore.Resource;
  if res = nil then
    exit;

  if MessageDlg(Format(RSConfirmDeleteRes, [res.Description]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    Dm.VpCLVPad.Datastore.DeleteResource(res);
    UpdateOtherResourcesList;
  end;
end;


end.

